Index: /trunk/Cocoa/Pester/Source/NJRUnfocusableMovieView.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRUnfocusableMovieView.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NJRUnfocusableMovieView.m	(revision 53)
@@ -0,0 +1,19 @@
+//
+//  NJRUnfocusableMovieView.m
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Dec 15 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "NJRUnfocusableMovieView.h"
+
+
+@implementation NJRUnfocusableMovieView
+
+- (BOOL)acceptsFirstResponder;
+{
+    return NO;
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.h	(revision 53)
@@ -15,6 +15,8 @@
 }
 
+- (void)setVoice:(NSString *)voice;
+
+- (id)delegate;
 - (void)setDelegate:(id)delegate;
-- (id)delegate;
 
 - (IBAction)stopVoicePreview:(id)sender;
Index: /trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/NJRVoicePopUpButton.m	(revision 53)
@@ -68,4 +68,14 @@
 }
 
+- (void)setVoice:(NSString *)voice;
+{
+    int voiceIdx = [self indexOfItemWithTitle: voice];
+    if (voiceIdx == -1) {
+        [self _invalidateVoiceSelection];
+    } else {
+        [self selectItemAtIndex: voiceIdx];
+    }
+}
+
 - (void)_previewVoice;
 {
@@ -80,5 +90,5 @@
 
     if ( (err = GetIndVoice(voiceIndex, &voice)) != noErr) {
-        NSBeginAlertSheet(@"Voice not available", @"OK", nil, nil, [self window], nil, nil, nil, nil, @"The voice Ò%@Ó you selected could not be used.  An error of type %ld occurred while attempting to retrieve voice information.", voiceName, err);
+        NSBeginAlertSheet(@"Voice not available", nil, nil, nil, [self window], nil, nil, nil, nil, @"The voice Ò%@Ó you selected could not be used.  An error of type %ld occurred while attempting to retrieve voice information.", voiceName, err);
         [self _invalidateVoiceSelection];
         return;
Index: /trunk/Cocoa/Pester/Source/NSAttributedString-NJRExtensions.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NSAttributedString-NJRExtensions.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NSAttributedString-NJRExtensions.h	(revision 53)
@@ -0,0 +1,16 @@
+//
+//  NSAttributedString-NJRExtensions.h
+//  Pester
+//
+//  Created by Nicholas Riley on Mon Dec 16 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface NSAttributedString (NJRExtensions)
+
+- (float)heightWrappedToWidth:(float)width;
+
+@end
Index: /trunk/Cocoa/Pester/Source/NSAttributedString-NJRExtensions.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NSAttributedString-NJRExtensions.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NSAttributedString-NJRExtensions.m	(revision 53)
@@ -0,0 +1,30 @@
+//
+//  NSAttributedString-NJRExtensions.m
+//  Pester
+//
+//  Created by Nicholas Riley on Mon Dec 16 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "NSAttributedString-NJRExtensions.h"
+
+@implementation NSAttributedString (NJRExtensions)
+
+- (float)heightWrappedToWidth:(float)width;
+{
+    float height = 0;
+    NSTextStorage *storage = [[NSTextStorage alloc] initWithAttributedString: self];
+    NSLayoutManager *layoutManager = [[NSLayoutManager alloc] init];
+    NSTextContainer *container = [[NSTextContainer alloc]
+        initWithContainerSize: NSMakeSize(width, MAXFLOAT)];
+    [layoutManager addTextContainer: container];
+    [storage addLayoutManager: layoutManager];
+    (void) [layoutManager glyphRangeForTextContainer: container]; // force layout
+    height = [layoutManager usedRectForTextContainer: container].size.height;
+    [layoutManager release];
+    [container release];
+    [storage release];
+    return height;
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/NSCalendarDate-NJRExtensions.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NSCalendarDate-NJRExtensions.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NSCalendarDate-NJRExtensions.h	(revision 53)
@@ -0,0 +1,17 @@
+//
+//  NSCalendarDate-NJRExtensions.h
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Dec 22 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <Foundation/Foundation.h>
+
+
+@interface NSCalendarDate (NJRExtensions)
+
++ (NSCalendarDate *)dateForDay:(NSDate *)date;
++ (NSCalendarDate *)dateWithDate:(NSDate *)date atTime:(NSDate *)time;
+
+@end
Index: /trunk/Cocoa/Pester/Source/NSCalendarDate-NJRExtensions.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NSCalendarDate-NJRExtensions.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NSCalendarDate-NJRExtensions.m	(revision 53)
@@ -0,0 +1,49 @@
+//
+//  NSCalendarDate-NJRExtensions.m
+//  Pester
+//
+//  Created by Nicholas Riley on Sun Dec 22 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "NSCalendarDate-NJRExtensions.h"
+
+
+@interface NSCalendarDate (Private)
+
+// implemented in Foundation, but not declared in NSDate.h
++ (NSCalendarDate *)dateWithDate:(NSDate *)date;
+
+@end
+
+@implementation NSCalendarDate (NJRExtensions)
+
++ (NSCalendarDate *)dateForDay:(NSDate *)date;
+{
+    NSCalendarDate *calDate = [NSCalendarDate dateWithDate: date];
+    return [NSCalendarDate dateWithYear: [calDate yearOfCommonEra]
+                                  month: [calDate monthOfYear]
+                                    day: [calDate dayOfMonth]
+                                   hour: 0
+                                 minute: 0
+                                 second: 0
+                               timeZone: nil];
+}
+
++ (NSCalendarDate *)dateWithDate:(NSDate *)date atTime:(NSDate *)time;
+{
+    NSCalendarDate *calTime, *calDate;
+    if (time == nil || date == nil) return nil;
+    calTime = [NSCalendarDate dateWithDate: time];
+    calDate = [NSCalendarDate dateWithDate: date];
+    if (calTime == nil || calDate == nil) return nil;
+    return [NSCalendarDate dateWithYear: [calDate yearOfCommonEra]
+                                  month: [calDate monthOfYear]
+                                    day: [calDate dayOfMonth]
+                                   hour: [calTime hourOfDay]
+                                 minute: [calTime minuteOfHour]
+                                 second: [calTime secondOfMinute]
+                               timeZone: nil];
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/NSDictionary-NJRExtensions.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NSDictionary-NJRExtensions.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NSDictionary-NJRExtensions.h	(revision 53)
@@ -0,0 +1,16 @@
+//
+//  NSDictionary-NJRExtensions.h
+//  Pester
+//
+//  Created by Nicholas Riley on Tue Nov 19 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <Foundation/Foundation.h>
+
+
+@interface NSDictionary (NJRExtensions)
+
+- (id)objectForRequiredKey:(NSString *)key;
+
+@end
Index: /trunk/Cocoa/Pester/Source/NSDictionary-NJRExtensions.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NSDictionary-NJRExtensions.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NSDictionary-NJRExtensions.m	(revision 53)
@@ -0,0 +1,21 @@
+//
+//  NSDictionary-NJRExtensions.m
+//  Pester
+//
+//  Created by Nicholas Riley on Tue Nov 19 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "NSDictionary-NJRExtensions.h"
+
+
+@implementation NSDictionary (NJRExtensions)
+
+- (id)objectForRequiredKey:(NSString *)key;
+{
+    id obj = [self objectForKey: key];
+    NSAssert1(obj != nil, @"Dictionary does not contain object for required key Ò%@Ó", key);
+    return obj;
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/NSString-NJRExtensions.h
===================================================================
--- /trunk/Cocoa/Pester/Source/NSString-NJRExtensions.h	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NSString-NJRExtensions.h	(revision 53)
@@ -0,0 +1,28 @@
+//
+//  NSString-NJRExtensions.h
+//  Pester
+//
+//  Created by Nicholas Riley on Mon Dec 16 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import <AppKit/AppKit.h>
+
+
+@interface NSString (NJRExtensions)
+
+- (NSAttributedString *)small;
+- (NSAttributedString *)smallBold;
+- (NSAttributedString *)underlined;
+
++ (NSString *)ellipsisString;
+
+
+@end
+
+@interface NSMutableString (NJRExtensions)
+
+- (void)truncateToLength:(unsigned)maxLength by:(NSLineBreakMode)method;
+- (void)truncateToWidth:(float)maxWidth by:(NSLineBreakMode)method withAttributes:(NSDictionary *)attributes;
+
+@end
Index: /trunk/Cocoa/Pester/Source/NSString-NJRExtensions.m
===================================================================
--- /trunk/Cocoa/Pester/Source/NSString-NJRExtensions.m	(revision 53)
+++ /trunk/Cocoa/Pester/Source/NSString-NJRExtensions.m	(revision 53)
@@ -0,0 +1,94 @@
+//
+//  NSString-NJRExtensions.m
+//  Pester
+//
+//  Created by Nicholas Riley on Mon Dec 16 2002.
+//  Copyright (c) 2002 Nicholas Riley. All rights reserved.
+//
+
+#import "NSString-NJRExtensions.h"
+
+@implementation NSString (NJRExtensions)
+
+- (NSAttributedString *)attributedStringWithFont:(NSFont *)font;
+{
+    return [[[NSAttributedString alloc] initWithString: self attributes: [NSDictionary dictionaryWithObject: font forKey: NSFontAttributeName]] autorelease];
+}
+
+- (NSAttributedString *)underlined;
+{
+    return [[[NSAttributedString alloc] initWithString: self attributes: [NSDictionary dictionaryWithObject: [NSNumber numberWithInt: NSSingleUnderlineStyle] forKey: NSUnderlineStyleAttributeName]] autorelease];
+}
+
+- (NSAttributedString *)small;
+{
+    return [self attributedStringWithFont: [NSFont systemFontOfSize: [NSFont smallSystemFontSize]]];
+}
+
+- (NSAttributedString *)smallBold;
+{
+    return [self attributedStringWithFont: [NSFont boldSystemFontOfSize: [NSFont smallSystemFontSize]]];
+}
+
++ (NSString *)ellipsisString;
+{
+    static NSString *ellipsis = nil;
+    if (ellipsis == nil) {
+        const unichar ellipsisChar = 0x2026;
+        ellipsis = [[NSString alloc] initWithCharacters: &ellipsisChar length: 1];
+    }
+    return ellipsis;
+}
+
+@end
+
+@implementation NSMutableString (NJRExtensions)
+
+- (void)truncateToLength:(unsigned)maxLength by:(NSLineBreakMode)method;
+{
+    if ([self length] > maxLength) {
+        NSRange range = {0, [self length] - maxLength};
+        switch (method) {
+            case NSLineBreakByTruncatingHead:
+                range.location = 0;
+                break;
+            case NSLineBreakByTruncatingMiddle:
+                range.location = maxLength / 2;
+                break;
+            case NSLineBreakByTruncatingTail:
+                range.location = maxLength;
+                break;
+            default:
+                range.location = maxLength;
+                break;
+        }
+        [self replaceCharactersInRange: range withString: [NSString ellipsisString]];
+    }
+}
+
+- (void)truncateToWidth:(float)maxWidth by:(NSLineBreakMode)method withAttributes:(NSDictionary *)attributes;
+{
+    if ([self sizeWithAttributes: attributes].width > maxWidth) {
+        float width;
+        int min = 0, max = [self length], avg;
+        NSMutableString *original = [self mutableCopy];
+        while (max >= min) {
+            avg = (max + min) / 2;
+            [self truncateToLength: avg by: method];
+            width = [self sizeWithAttributes: attributes].width;
+            if (width > maxWidth) {
+                max = avg - 1; // too wide
+            } else if (width == maxWidth) {
+                break;
+            } else {
+                min = avg + 1; // too narrow
+                [self setString: original];
+            }
+        }
+        if (width != maxWidth)
+            [self truncateToLength: max by: method];
+        [original release];
+    }
+}
+
+@end
Index: /trunk/Cocoa/Pester/Source/PSAlarm.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarm.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSAlarm.h	(revision 53)
@@ -8,24 +8,32 @@
 
 #import <Foundation/Foundation.h>
+#import "PSPropertyListSerialization.h"
 
 typedef enum {
-    PSAlarmInvalid, PSAlarmInterval, PSAlarmDate, PSAlarmSet
+    PSAlarmInvalid, // incorrectly specified
+    PSAlarmInterval, // interval specified (possibly repeating)
+    PSAlarmDate, // date specified
+    PSAlarmSet, // pending, timer set
+    PSAlarmSnooze, // expired alarm with snooze interval set (possibly repeating)
+    PSAlarmExpired // expired alarm (possibly repeating)
 } PSAlarmType;
 
 extern NSString * const PSAlarmTimerSetNotification;
 extern NSString * const PSAlarmTimerExpiredNotification;
+extern NSString * const PSAlarmDiedNotification;
 
-// XXX figure out how to support reading old alarms
+@class PSAlert, PSAlerts;
 
-@class PSAlert;
-
-@interface PSAlarm : NSObject <NSCoding> {
-    PSAlarmType alarmType;
+@interface PSAlarm : NSObject <NSCoding, PSPropertyListSerialization> {
+    PSAlarmType alarmType; // changes during lifetime of alarm; more like a state
     NSCalendarDate *alarmDate;
     NSTimeInterval alarmInterval;
+    NSTimeInterval snoozeInterval;
+    NSTimeInterval timeRemaining;
     NSString *alarmMessage;
     NSString *invalidMessage;
     NSTimer *timer;
-    NSMutableArray *alerts;
+    PSAlerts *alerts;
+    BOOL repeating;
 }
 
@@ -34,16 +42,23 @@
 - (void)setForDate:(NSDate *)date atTime:(NSDate *)time;
 - (void)setMessage:(NSString *)aMessage;
-- (void)addAlert:(PSAlert *)alert;
-- (void)removeAlerts;
+- (void)setAlerts:(PSAlerts *)theAlerts;
+- (void)setRepeating:(BOOL)isRepeating;
+- (void)setSnoozeInterval:(NSTimeInterval)anInterval;
 
 - (NSCalendarDate *)date;
 - (NSCalendarDate *)time;
 - (NSTimeInterval)interval;
+- (NSTimeInterval)timeRemaining;
 - (NSString *)message;
-- (NSArray *)alerts;
+- (PSAlerts *)alerts;
+- (BOOL)isRepeating;
+- (NSTimeInterval)snoozeInterval; // most recent interval (nonzero return does not indicate alarm is snoozing or set to snooze)
 
 - (NSString *)dateString;
 - (NSString *)shortDateString;
 - (NSString *)timeString;
+- (NSString *)dateTimeString; // current or next alarm time
+- (NSString *)nextDateTimeString; // next alarm time
+- (NSString *)intervalString;
 - (NSString *)timeRemainingString;
 
@@ -51,9 +66,15 @@
 - (NSString *)invalidMessage;
 
+- (NSAttributedString *)prettyDescription;
+
 - (NSComparisonResult)compareDate:(PSAlarm *)otherAlarm;
 - (NSComparisonResult)compareMessage:(PSAlarm *)otherAlarm;
 
-- (BOOL)setTimer;
+- (BOOL)setTimer; // or die, if expired and no snooze/repeat
 - (void)cancelTimer;
 
+// 1.1 only, going away when we move to keyed archiving
+- (NSDictionary *)propertyListRepresentation;
+- (id)initWithPropertyList:(NSDictionary *)dict;
+
 @end
Index: /trunk/Cocoa/Pester/Source/PSAlarm.m
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarm.m	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSAlarm.m	(revision 53)
@@ -9,8 +9,22 @@
 #import "PSAlarm.h"
 #import "PSAlert.h"
+#import "PSAlerts.h"
 #import "NJRDateFormatter.h"
+#import "NSCalendarDate-NJRExtensions.h"
+#import "NSDictionary-NJRExtensions.h"
+#import "NSString-NJRExtensions.h"
 
 NSString * const PSAlarmTimerSetNotification = @"PSAlarmTimerSetNotification";
 NSString * const PSAlarmTimerExpiredNotification = @"PSAlarmTimerExpiredNotification";
+NSString * const PSAlarmDiedNotification = @"PSAlarmDiedNotification";
+
+// property list keys
+static NSString * const PLAlarmType = @"type"; // NSString
+static NSString * const PLAlarmDate = @"date"; // NSNumber
+static NSString * const PLAlarmInterval = @"interval"; // NSNumber
+static NSString * const PLAlarmSnoozeInterval = @"snooze interval"; // NSNumber
+static NSString * const PLAlarmMessage = @"message"; // NSString
+static NSString * const PLAlarmAlerts = @"alerts"; // NSDictionary
+static NSString * const PLAlarmRepeating = @"repeating"; // NSNumber
 
 static NSString *dateFormat, *shortDateFormat, *timeFormat;
@@ -72,11 +86,10 @@
     invalidMessage = nil;
     alarmType = type;
+    if (type != PSAlarmInterval) [self setRepeating: NO];
 }
 
 - (void)_setDateFromInterval;
 {
-    [alarmDate release]; alarmDate = nil;
-    alarmDate = [NSCalendarDate dateWithTimeIntervalSinceNow: alarmInterval];
-    [alarmDate retain];
+    [self _setAlarmDate: [NSCalendarDate dateWithTimeIntervalSinceNow: alarmInterval]];
     [self _beValidWithType: PSAlarmInterval];
 }
@@ -84,5 +97,5 @@
 - (void)_setIntervalFromDate;
 {
-    alarmInterval = [alarmDate timeIntervalSinceNow] + 1;
+    alarmInterval = [alarmDate timeIntervalSinceNow];
     if (alarmInterval <= 0) {
         [self _beInvalid: @"Please specify an alarm time in the future."];
@@ -90,4 +103,16 @@
     }
     [self _beValidWithType: PSAlarmDate];
+}
+
+- (PSAlarmType)_alarmTypeForString:(NSString *)string;
+{
+    if ([string isEqualToString: @"PSAlarmDate"]) return PSAlarmDate;
+    if ([string isEqualToString: @"PSAlarmInterval"]) return PSAlarmInterval;
+    if ([string isEqualToString: @"PSAlarmSet"]) return PSAlarmSet;
+    if ([string isEqualToString: @"PSAlarmInvalid"]) return PSAlarmInvalid;
+    if ([string isEqualToString: @"PSAlarmSnooze"]) return PSAlarmSnooze;
+    if ([string isEqualToString: @"PSAlarmExpired"]) return PSAlarmExpired;
+    NSLog(@"unknown alarm type string: %@", string);
+    return nil;
 }
 
@@ -99,10 +124,27 @@
         case PSAlarmSet: return @"PSAlarmSet";
         case PSAlarmInvalid: return @"PSAlarmInvalid";
+        case PSAlarmSnooze: return @"PSAlarmSnooze";
+        case PSAlarmExpired: return @"PSAlarmExpired";
         default: return [NSString stringWithFormat: @"<unknown: %u>", alarmType];
     }
 }
 
+- (NSString *)_stringForInterval:(unsigned long long)interval;
+{
+    const unsigned long long minute = 60, hour = minute * 60, day = hour * 24, year = day * 365.26;
+    // +[NSString stringWithFormat:] in 10.1 does not support long longs: work around it by converting to unsigned ints or longs for display
+    if (interval == 0) return nil;
+    if (interval < minute) return [NSString stringWithFormat: @"%us", (unsigned)interval];
+    if (interval < day) return [NSString stringWithFormat: @"%uh %um", (unsigned)(interval / hour), (unsigned)((interval % hour) / minute)];
+    if (interval < 2 * day) return @"One day";
+    if (interval < year) return [NSString stringWithFormat: @"%u days", (unsigned)(interval / day)];
+    if (interval < 2 * year) return @"One year";
+    return [NSString stringWithFormat: @"%lu years", (unsigned long)(interval / year)];
+}
+
 - (void)_timerExpired:(NSTimer *)aTimer;
 {
+    NSLog(@"expired: %@; now %@", [[aTimer fireDate] description], [[NSDate date] description]);
+    alarmType = PSAlarmExpired;
     [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmTimerExpiredNotification object: self];
     [timer release]; timer = nil;
@@ -128,5 +170,5 @@
 - (void)setForDate:(NSDate *)date atTime:(NSDate *)time;
 {
-    NSCalendarDate *calTime, *calDate;
+    NSCalendarDate *dateTime;
     if (time == nil && date == nil) {
         [self _beInvalid: @"Please specify an alarm date and time."]; return;
@@ -139,17 +181,21 @@
     }
     // XXX if calTime's date is different from the default date, complain
-    calTime = [NSCalendarDate dateWithTimeIntervalSinceReferenceDate: [time timeIntervalSinceReferenceDate]];
-    calDate = [NSCalendarDate dateWithTimeIntervalSinceReferenceDate: [date timeIntervalSinceReferenceDate]];
-    if (calTime == nil || calDate == nil) {
+    dateTime = [NSCalendarDate dateWithDate: date atTime: time];
+    if (dateTime == nil) {
         [self _beInvalid: @"Please specify a reasonable date and time."];
     }
-    [self setForDateAtTime:
-        [[[NSCalendarDate alloc] initWithYear: [calDate yearOfCommonEra]
-                                        month: [calDate monthOfYear]
-                                          day: [calDate dayOfMonth]
-                                         hour: [calTime hourOfDay]
-                                       minute: [calTime minuteOfHour]
-                                       second: [calTime secondOfMinute]
-                                     timeZone: nil] autorelease]];
+    [self setForDateAtTime: dateTime];
+}
+
+- (void)setRepeating:(BOOL)isRepeating;
+{
+    repeating = isRepeating;
+}
+
+- (void)setSnoozeInterval:(NSTimeInterval)anInterval;
+{
+    snoozeInterval = anInterval;
+    NSAssert(alarmType == PSAlarmExpired, @"CanÕt snooze an alarm that hasnÕt expired");
+    alarmType = PSAlarmSnooze;
 }
 
@@ -175,5 +221,7 @@
 {
     if (alarmType == PSAlarmDate) [self _setIntervalFromDate];
-    return (alarmType != PSAlarmInvalid);
+    if (alarmType == PSAlarmInvalid ||
+        (alarmType == PSAlarmExpired && ![self isRepeating])) return NO;
+    return YES;
 }
 
@@ -204,22 +252,34 @@
 - (NSTimeInterval)interval;
 {
-    if (alarmType == PSAlarmSet || alarmType == PSAlarmDate) [self _setIntervalFromDate];
+    if (alarmType == PSAlarmDate) [self _setIntervalFromDate];
     return alarmInterval;
 }
 
-- (void)addAlert:(PSAlert *)alert;
-{
-    if (alerts == nil) alerts = [[NSMutableArray alloc] initWithCapacity: 4];
-    [alerts addObject: alert];
-}
-
-- (void)removeAlerts;
-{
-    [alerts removeAllObjects];
-}
-
-- (NSArray *)alerts;
-{
-    return [[alerts copy] autorelease];
+- (NSTimeInterval)snoozeInterval;
+{
+    return snoozeInterval;
+}
+
+- (NSTimeInterval)timeRemaining;
+{
+    NSAssert1(alarmType == PSAlarmSet, @"CanÕt get time remaining on alarm with no timer set: %@", self);
+    return -[[NSDate date] timeIntervalSinceDate: alarmDate];
+}
+
+- (void)setAlerts:(PSAlerts *)theAlerts;
+{
+    [alerts release]; alerts = nil;
+    alerts = [theAlerts retain];
+}
+
+- (PSAlerts *)alerts;
+{
+    if (alerts == nil) alerts = [[PSAlerts alloc] init];
+    return alerts;
+}
+
+- (BOOL)isRepeating;
+{
+    return repeating;
 }
 
@@ -239,15 +299,64 @@
 }
 
+- (NSString *)dateTimeString;
+{
+    return [NSString stringWithFormat: @"%@ at %@", [self dateString], [self timeString]];
+}
+
+- (NSString *)nextDateTimeString;
+{
+    if (![self isRepeating]) {
+        return nil;
+    } else {
+        NSCalendarDate *date = [[NSCalendarDate alloc] initWithTimeIntervalSinceNow: [self interval]];
+        NSString *nextDateTimeString = [NSString stringWithFormat: @"%@ at %@",
+            [date descriptionWithCalendarFormat: dateFormat locale: locale],
+            [date descriptionWithCalendarFormat: timeFormat locale: locale]];
+        [date release];
+        return nextDateTimeString;
+    }
+}
+
+- (NSString *)intervalString;
+{
+    const unsigned long long mval = 99, minute = 60, hour = minute * 60;
+    unsigned long long interval = [self interval];
+    if (interval == 0) return nil;
+    if (interval == 1) return @"One second";
+    if (interval == minute) return @"One minute";
+    if (interval % minute == 0) return [NSString stringWithFormat: @"%u minutes", (unsigned)(interval / minute)];
+    if (interval <= mval) return [NSString stringWithFormat: @"%u seconds", (unsigned)interval];
+    if (interval == hour) return @"One hour";
+    if (interval % hour == 0) return [NSString stringWithFormat: @"%u hours", (unsigned)(interval / hour)];
+    if (interval <= mval * minute) return [NSString stringWithFormat: @"%u minutes", (unsigned)(interval / minute)];
+    if (interval <= mval * hour) return [NSString stringWithFormat: @"%u hours", (unsigned)(interval / hour)];
+    return [self _stringForInterval: interval];
+}
+
 - (NSString *)timeRemainingString;
 {
-    static const unsigned long long minute = 60, hour = minute * 60, day = hour * 24, year = day * 365.26;
-    unsigned long long interval = [self interval];
-    // +[NSString stringWithFormat:] in 10.1 does not support long longs: work around it by converting to unsigned ints or longs for display
-    if (interval == 0) return @"ÇexpiredÈ";
-    if (interval < minute) return [NSString stringWithFormat: @"%us", (unsigned)interval];
-    if (interval < day) return [NSString stringWithFormat: @"%uh %um", (unsigned)(interval / hour), (unsigned)((interval % hour) / minute)];
-    if (interval < year) return [NSString stringWithFormat: @"%u days", (unsigned)(interval / day)];
-    if (interval < 2 * year) return @"One year";
-    return [NSString stringWithFormat: @"%lu years", (unsigned long)(interval / year)];
+    NSString *timeRemainingString = [self _stringForInterval: llround([self timeRemaining])];
+    
+    if (timeRemainingString == nil) return @"ÇexpiredÈ";
+    return timeRemainingString;
+}
+
+- (NSAttributedString *)prettyDescription;
+{
+    NSMutableAttributedString *string = [[NSMutableAttributedString alloc] init];
+    NSAttributedString *alertList = [alerts prettyList];
+
+    [string appendAttributedString:
+        [[NSString stringWithFormat: @"At alarm time for Ò%@Ó:\n", [self message]] small]];
+    if (alertList != nil) {
+        [string appendAttributedString: alertList];
+    } else {
+        [string appendAttributedString: [@"Do nothing." small]];
+    }
+    if ([self isRepeating]) {
+        [string appendAttributedString:
+            [[NSString stringWithFormat: @"\nAlarm repeats every %@.", [[self intervalString] lowercaseString]] small]];
+    }
+    return [string autorelease];
 }
 
@@ -256,17 +365,25 @@
 - (BOOL)setTimer;
 {
-    switch (alarmType) {
-        case PSAlarmDate: if (![self isValid]) return NO;
-        case PSAlarmInterval:
-            timer = [NSTimer scheduledTimerWithTimeInterval: alarmInterval target: self selector: @selector(_timerExpired:) userInfo: nil repeats: NO];
-            if (timer != nil) {
-                [timer retain];
-                alarmType = PSAlarmSet;
-                [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmTimerSetNotification object: self];
-                return YES;
-            }
-        default:
+    if (alarmType == PSAlarmExpired) {
+        if ([self isRepeating]) {
+            [self _setDateFromInterval];
+        } else {
+            [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmDiedNotification object: self];
             return NO;
-    }
+        }
+    } else if (alarmType == PSAlarmDate) {
+        if (![self isValid]) return NO;
+    } else if (alarmType == PSAlarmSnooze) {
+        [self _setAlarmDate: [NSCalendarDate dateWithTimeIntervalSinceNow: snoozeInterval]];
+    } else if (alarmType != PSAlarmInterval) {
+        return NO;
+    }
+    timer = [NSTimer scheduledTimerWithTimeInterval: (alarmType == PSAlarmSnooze ? snoozeInterval : alarmInterval) target: self selector: @selector(_timerExpired:) userInfo: nil repeats: NO];
+    if (timer == nil) return NO;
+    [timer retain];
+    alarmType = PSAlarmSet;
+    [[NSNotificationCenter defaultCenter] postNotificationName: PSAlarmTimerSetNotification object: self];
+    // NSLog(@"set: %@; now %@; remaining %@", [[timer fireDate] description], [[NSDate date] description], [self timeRemainingString]);
+    return YES;
 }
 
@@ -274,4 +391,5 @@
 {
     [timer invalidate]; [timer release]; timer = nil;
+    [self setRepeating: NO];
 }
 
@@ -300,5 +418,80 @@
 }
 
-#pragma mark archiving
+#pragma mark property list serialization (Pester 1.1)
+
+- (NSDictionary *)propertyListRepresentation;
+{
+    NSMutableDictionary *dict = [NSMutableDictionary dictionaryWithCapacity: 5];
+    if (![self isValid]) return nil;
+    [dict setObject: [self _alarmTypeString] forKey: PLAlarmType];
+    switch (alarmType) {
+        case PSAlarmDate:
+        case PSAlarmSet:
+            [dict setObject: [NSNumber numberWithDouble: [alarmDate timeIntervalSinceReferenceDate]] forKey: PLAlarmDate];
+            break;
+        case PSAlarmSnooze:
+        case PSAlarmInterval:
+        case PSAlarmExpired:
+            [dict setObject: [NSNumber numberWithDouble: alarmInterval] forKey: PLAlarmInterval];
+            [dict setObject: [NSNumber numberWithBool: repeating] forKey: PLAlarmRepeating];
+            break;
+        default:
+            NSAssert1(NO, @"CanÕt save alarm type %@", [self _alarmTypeString]);
+            break;
+    }
+    if (snoozeInterval != 0)
+        [dict setObject: [NSNumber numberWithDouble: snoozeInterval] forKey: PLAlarmSnoozeInterval];
+    [dict setObject: alarmMessage forKey: PLAlarmMessage];
+    if (alerts != nil) {
+        [dict setObject: [alerts propertyListRepresentation] forKey: PLAlarmAlerts];
+    }
+    return dict;
+}
+
+- (id)initWithPropertyList:(NSDictionary *)dict;
+{
+    if ( (self = [self init]) != nil) {
+        PSAlerts *alarmAlerts;
+        alarmType = [self _alarmTypeForString: [dict objectForRequiredKey: PLAlarmType]];
+        switch (alarmType) {
+            case PSAlarmDate:
+            case PSAlarmSet:
+               { NSCalendarDate *date = [[NSCalendarDate alloc] initWithTimeIntervalSinceReferenceDate: [[dict objectForRequiredKey: PLAlarmDate] doubleValue]];
+                [self _setAlarmDate: date];
+                [date release];
+               }
+                break;
+            case PSAlarmSnooze: // snooze interval set but not confirmed; ignore
+                alarmType = PSAlarmExpired;
+            case PSAlarmInterval:
+            case PSAlarmExpired:
+                alarmInterval = [[dict objectForRequiredKey: PLAlarmInterval] doubleValue];
+                repeating = [[dict objectForRequiredKey: PLAlarmRepeating] boolValue];
+                break;
+            default:
+                NSAssert1(NO, @"CanÕt load alarm type %@", [self _alarmTypeString]);
+                break;
+        }
+        snoozeInterval = [[dict objectForKey: PLAlarmSnoozeInterval] doubleValue];
+        [self setMessage: [dict objectForRequiredKey: PLAlarmMessage]];
+        alarmAlerts = [[PSAlerts alloc] initWithPropertyList: [dict objectForRequiredKey: PLAlarmAlerts]];
+        [self setAlerts: alarmAlerts];
+        [alarmAlerts release];
+        if (alarmType == PSAlarmSet) {
+            alarmType = PSAlarmDate;
+            [self setTimer];
+        }
+        if (alarmType == PSAlarmExpired) {
+            [self setTimer];
+            if (alarmType == PSAlarmExpired) { // failed to restart
+                [self release];
+                self = nil;
+            }
+        }
+    }
+    return self;
+}
+
+#pragma mark archiving (Pester 1.0)
 
 - (void)encodeWithCoder:(NSCoder *)coder;
@@ -324,5 +517,8 @@
 - (id)initWithCoder:(NSCoder *)coder;
 {
-    if ( (self = [super init]) != nil) {
+    if ( (self = [self init]) != nil) {
+        PSAlerts *legacyAlerts = [[PSAlerts alloc] initWithPesterVersion1Alerts];
+        [self setAlerts: legacyAlerts];
+        [legacyAlerts release];
         [coder decodeValueOfObjCType: @encode(PSAlarmType) at: &alarmType];
         switch (alarmType) {
Index: /trunk/Cocoa/Pester/Source/PSAlarmAlertController.h
===================================================================
--- /trunk/Cocoa/Pester/Source/PSAlarmAlertController.h	(revision 52)
+++ /trunk/Cocoa/Pester/Source/PSAlarmAlertController.h	(revision 53)
@@ -13,5 +13,7 @@
 
 @interface PSAlarmAlertController : NSObject {
-
+    NSMutableSet *pendingAlerts;
+    ProcessSerialNumber frontmostApp;
+    BOOL appWasHidden;
 }
 
